import { StudioTemplatePropertyType } from "src/common/studio/studio-model";
import { EntityWithPath } from "../../template-model/pieces/entity";
export interface EntityAnswer {
    entity: EntityWithPath;
}
export declare const entityQuestion: {
    code: string;
    caption: string;
    propertyType: StudioTemplatePropertyType;
    required: boolean;
};
export interface ComponentNameAnswer {
    componentName: string;
}
interface ComponentNameQuestionOption {
    defaultValue: string;
    code?: string;
    caption?: string;
    required?: boolean;
}
export declare const createComponentNameQuestion: (options: ComponentNameQuestionOption) => {
    code: string;
    caption: string;
    propertyType: StudioTemplatePropertyType;
    defaultValue: string;
    required: true;
};
export interface MenuItemAnswer {
    menuItem: string | null;
}
export declare const menuItemQuestion: {
    caption: string;
    code: string;
    propertyType: StudioTemplatePropertyType;
    required: boolean;
};
export interface QueryAnswer {
    query: string;
}
interface QueryQuestionOptions {
    code?: string;
    caption?: string;
    defaultValue?: string;
    relatedProperty?: string;
    required?: boolean;
}
export declare const createQueryQuestion: (options?: QueryQuestionOptions) => {
    code: string;
    caption: string;
    propertyType: StudioTemplatePropertyType;
    relatedProperty: string;
    required: true;
};
export {};
