"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createQueryQuestion = exports.menuItemQuestion = exports.createComponentNameQuestion = exports.entityQuestion = void 0;
exports.entityQuestion = {
    code: 'entity',
    caption: 'Entity',
    propertyType: "ENTITY" /* StudioTemplatePropertyType.ENTITY */,
    required: true
};
const createComponentNameQuestion = (options) => ({
    code: options?.code || 'componentName',
    caption: options?.caption || 'Component name',
    propertyType: "POLYMER_COMPONENT_NAME" /* StudioTemplatePropertyType.POLYMER_COMPONENT_NAME */,
    defaultValue: options?.defaultValue,
    required: options?.required || true,
});
exports.createComponentNameQuestion = createComponentNameQuestion;
exports.menuItemQuestion = {
    caption: "Menu item",
    code: "menuItem",
    propertyType: "MENU_ITEM" /* StudioTemplatePropertyType.MENU_ITEM */,
    required: false
};
const createQueryQuestion = (options) => ({
    code: options?.code || 'query',
    // Subject to change, in future we might want to get the full query from Studio
    caption: options?.caption || 'GraphQL query for screen',
    propertyType: "GRAPHQL_QUERY" /* StudioTemplatePropertyType.GRAPHQL_QUERY */,
    relatedProperty: options?.relatedProperty || "entity",
    required: options?.required || true
});
exports.createQueryQuestion = createQueryQuestion;
//# sourceMappingURL=defaultAnswers.js.map