"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultConfigureGenerator = void 0;
const tslib_1 = require("tslib");
const path_1 = tslib_1.__importDefault(require("path"));
const inquirer_autocomplete_prompt_1 = tslib_1.__importDefault(require("inquirer-autocomplete-prompt"));
const createEjsRenameTransform_1 = require("./createEjsRenameTransform");
const createFormatTransform_1 = require("./createFormatTransform");
const defaultConfigureGenerator = (templateDir, gen, options) => {
    const { dest, templateOverride } = options;
    if (dest != null) {
        gen.destinationRoot(path_1.default.isAbsolute(dest) ? dest : path_1.default.join(gen.destinationRoot(), dest));
    }
    gen.sourceRoot(templateOverride ?? templateDir);
    // @ts-ignore this.env.adapter is missing in the typings
    gen.env.adapter.promptModule.registerPrompt('autocomplete', inquirer_autocomplete_prompt_1.default);
    gen.queueTransformStream([(0, createEjsRenameTransform_1.createEjsRenameTransform)(), (0, createFormatTransform_1.createFormatTransform)()]);
};
exports.defaultConfigureGenerator = defaultConfigureGenerator;
//# sourceMappingURL=defaultConfigureGenerator.js.map