"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deriveScreenTemplateModel = void 0;
const utils_1 = require("../../../../../common/utils");
const graphql_1 = require("graphql");
function deriveScreenTemplateModel(options, answers, schema) {
    const { componentName, shouldAddToMenu, route } = answers;
    return {
        relDirShift: (0, utils_1.normalizeImportRelativePath)(options.dirShift),
        componentName,
        route,
        caption: (0, utils_1.splitByCapitalLetter)(componentName),
        shouldAddToMenu,
        schema: schema ? (0, graphql_1.printSchema)(schema, { commentDescriptions: true }) : undefined
    };
}
exports.deriveScreenTemplateModel = deriveScreenTemplateModel;
//# sourceMappingURL=ScreenTemplateModel.js.map