"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deriveEntityCommon = void 0;
const tslib_1 = require("tslib");
const utils_1 = require("../../../../common/utils");
const path = tslib_1.__importStar(require("path"));
const includesPath = (...paths) => path.join(__dirname, '../../../../building-blocks/includes', ...paths);
/**
 * To be used in all entity management templates
 *
 * @param options
 * @param answers
 */
function deriveEntityCommon(options, answers) {
    const className = (0, utils_1.elementNameToClass)(answers.componentName);
    const componentName = answers.componentName;
    const relDirShift = (0, utils_1.normalizeImportRelativePath)(options.dirShift);
    const nameLiteral = (0, utils_1.unCapitalizeFirst)(className);
    const menuItem = answers.menuItem;
    const shouldAddToMenu = true;
    return {
        className,
        componentName,
        relDirShift,
        nameLiteral,
        menuItem,
        shouldAddToMenu,
        includesPath,
    };
}
exports.deriveEntityCommon = deriveEntityCommon;
//# sourceMappingURL=common.js.map