import { EntityAttribute, ProjectModel } from "../../../../common/model/cuba-model";
import { EntityWithPath } from "./entity";
import { RelationalAttributes, RelationImport } from "./relations";
export type EntityEditorTemplateModel = {
    readOnlyFields: string[];
    compositions: RelationalAttributes;
    associations: RelationalAttributes;
    nestedEntityInfo?: Record<string, string>;
    relationImports: RelationImport[];
    associatedEntityClassNames: string[];
};
export type EntityEditorAnswers = {
    entity: EntityWithPath;
    nestedEntityInfo?: Record<string, string>;
};
/**
 * Derives template model that is common for editors (does not include edit attributes as there are multiple ways
 * of obtaining them depending on whether we use REST or GraphQL).
 *
 * @param answers
 * @param projectModel
 * @param editAttributes
 * @param entityWithPath
 */
export declare function deriveEditorTemplateModel(answers: EntityEditorAnswers, projectModel: ProjectModel, editAttributes: EntityAttribute[]): EntityEditorTemplateModel;
