import { GraphQLEnumValue, GraphQLType } from "graphql";
import { Entity, ProjectModel } from "../../../../common/model/cuba-model";
import { FileAttributesEditPropertiesAnswer } from "../../../../generators/react-admin/entity-edit/answers";
import { FileAttributesListPropertiesAnswer } from "../../../../generators/react-admin/entity-list/answers";
import { FileAttributesShowPropertiesAnswer } from "../../../../generators/react-admin/entity-show/answers";
export interface FileAttributesProperties extends FileAttributesEditPropertiesAnswer, FileAttributesListPropertiesAnswer, FileAttributesShowPropertiesAnswer {
    uploadUrlQueryName?: string;
    downloadUrlQueryName?: string;
}
export interface GqlAttributeModel {
    kind: 'gql';
    tsType?: string;
    name: string | string[];
    type: string;
    gqlType: GraphQLType;
    displayName: string;
    enumOptions?: Array<GraphQLEnumValue>;
    fileProperties?: FileAttributesProperties;
    isFileType?: boolean;
    isEnumType?: boolean;
    isDateType?: boolean;
    isNumberType?: boolean;
    isSingleRelationField: boolean;
    isMultiRelationField: boolean;
    nestedAttributes?: string[];
    required?: boolean;
}
export declare function isGqlAttributeModel(attr: AttributeModel): attr is GqlAttributeModel;
export interface TsAttributeModel {
    kind: 'ts';
    tsType?: string;
    name: string;
    displayName: string;
}
export declare function isTsAttributeModel(attr: AttributeModel): attr is TsAttributeModel;
export type AttributeModel = GqlAttributeModel | TsAttributeModel;
export interface EntityWithPath extends Entity {
    path: string;
}
export interface EntityTemplateModel {
    entity: EntityWithPath;
}
export interface EntityAnswers {
    entity: Entity;
}
export declare function deriveEntity(answers: EntityAnswers, projectModel: ProjectModel): EntityTemplateModel;
