"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const test_commons_1 = require("../../../../../test/test-commons");
const getAttributeNames_1 = require("./getAttributeNames");
const chai_1 = require("chai");
describe("getAttributeNames", async () => {
    let schema;
    before(async () => {
        schema = await (0, test_commons_1.getMockSchema)();
    });
    it("determines all attributes based on schema", () => {
        const attrs = (0, getAttributeNames_1.getAttributeNames)("PetDTO", schema);
        (0, chai_1.expect)(attrs.sort()).to.deep.equal([
            "id",
            "identificationNumber",
            "owner",
            "passport",
            "passportContentType",
            "passportFilename",
            "photo",
            "birthDate",
            "description",
            "diseases",
            "tags",
            "type",
            "weightInGrams"
        ].sort());
    });
});
//# sourceMappingURL=getAttributeNames.test.js.map