"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEntityName = void 0;
const graphql_1 = require("graphql");
const unpackPaginationType_1 = require("./unpackPaginationType");
const unwrapGraphQLType_1 = require("./unwrapGraphQLType");
function getEntityName(queryName, schema) {
    const field = schema.getQueryType()?.getFields()?.[queryName];
    if (field == null) {
        throw new Error(`queryName: ${queryName}, field is null`);
    }
    const type = (0, unwrapGraphQLType_1.unwrapGraphQLType)(field.type);
    if (type == null) {
        throw new Error(`queryName: ${queryName}, cannot find type in field: ${JSON.stringify(field)}`);
    }
    const entityType = (0, graphql_1.isInputObjectType)(type) || (0, graphql_1.isObjectType)(type)
        ? (0, unpackPaginationType_1.unpackPaginationType)(type, schema)
        : type;
    return (0, graphql_1.getNamedType)(entityType).name;
}
exports.getEntityName = getEntityName;
//# sourceMappingURL=getEntityName.js.map