"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const test_commons_1 = require("../../../../../test/test-commons");
const getEntityName_1 = require("./getEntityName");
const chai_1 = require("chai");
describe('getEntityName', async () => {
    let schema;
    before(async () => {
        schema = await (0, test_commons_1.getMockSchema)();
    });
    it('determines entity name', () => {
        const entityName = (0, getEntityName_1.getEntityName)('petList', schema);
        (0, chai_1.expect)(entityName).to.eq('PetDTO');
    });
    it('determines entity name for query with result page', () => {
        const entityName = (0, getEntityName_1.getEntityName)('ownerListWithResultPage', schema);
        (0, chai_1.expect)(entityName).to.eq('Owner');
    });
});
//# sourceMappingURL=getEntityName.test.js.map