"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGraphQLTypeByArgumentName = void 0;
const getGraphQLTypeByRelativePath_1 = require("./getGraphQLTypeByRelativePath");
function getGraphQLTypeByArgumentName(schema, field, argumentName) {
    const [head, ...tail] = argumentName;
    const argType = field.args.find(arg => arg.name === head)?.type;
    if (argType == null)
        throw new Error(`Arg '${head}' don't exist in the ${field.type.toString()} field`);
    return (0, getGraphQLTypeByRelativePath_1.getGraphQLTypeByRelativePath)(schema, argType, tail);
}
exports.getGraphQLTypeByArgumentName = getGraphQLTypeByArgumentName;
//# sourceMappingURL=getGraphQLTypeByArgumentName.js.map