"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const test_commons_1 = require("../../../../../test/test-commons");
const getGraphQLTypeByArgumentName_1 = require("./getGraphQLTypeByArgumentName");
const chai_1 = require("chai");
describe('getGraphQLTypeByArgumentName', async () => {
    let schema;
    before(async () => {
        schema = await (0, test_commons_1.getMockSchema)();
    });
    it('not deep', () => {
        const queryType = schema.getQueryType();
        if (queryType == null)
            throw new Error();
        const typeWithArgs = queryType.getFields()['petByIdentificationNumberList'];
        if (typeWithArgs == null)
            throw new Error();
        const firstNameType = (0, getGraphQLTypeByArgumentName_1.getGraphQLTypeByArgumentName)(schema, typeWithArgs, ['identificationNumber']);
        (0, chai_1.expect)(firstNameType.toString()).to.eq('String');
    });
    it('deep', () => {
        const queryType = schema.getQueryType();
        if (queryType == null)
            throw new Error();
        const filterArgType = queryType.getFields()['ownerByNamesList'];
        if (filterArgType == null)
            throw new Error();
        const agrType = (0, getGraphQLTypeByArgumentName_1.getGraphQLTypeByArgumentName)(schema, filterArgType, ['filter']);
        (0, chai_1.expect)(agrType.toString()).to.eq('OwnerFilterInput');
        const firstNameType = (0, getGraphQLTypeByArgumentName_1.getGraphQLTypeByArgumentName)(schema, filterArgType, ['filter', 'firstName']);
        (0, chai_1.expect)(firstNameType.toString()).to.eq('String');
        const lastNameType = (0, getGraphQLTypeByArgumentName_1.getGraphQLTypeByArgumentName)(schema, filterArgType, ['filter', 'lastName']);
        (0, chai_1.expect)(lastNameType.toString()).to.eq('String');
    });
});
//# sourceMappingURL=getGraphQLTypeByArgumentName.test.js.map