"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const getSelectedFieldNamesFromTopField_1 = require("./getSelectedFieldNamesFromTopField");
const chai_1 = require("chai");
const graphql_tag_1 = tslib_1.__importDefault(require("graphql-tag"));
describe('getSelectedFieldNamesFromTopField', async () => {
    it('select field names from top field', () => {
        const selectedFieldNames = (0, getSelectedFieldNamesFromTopField_1.getSelectedFieldNamesFromTopField)((0, graphql_tag_1.default)(`query {
      topField {
        one
        two
        three {
          five
        }
        four
      }
    }`));
        (0, chai_1.expect)(selectedFieldNames).to.deep.eq([
            'one',
            'two',
            'three',
            'four',
        ]);
    });
});
//# sourceMappingURL=getSelectedFieldNamesFromTopField.test.js.map