"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unpackPaginationFields = void 0;
function unpackPaginationFields(fields) {
    const content = fields.find(field => field.kind === 'Field' && field.name.value === 'content' && Array.isArray(field.selectionSet?.selections));
    const totalElements = fields.find(field => field.kind === 'Field' && field.name.value === 'totalElements');
    if (content != null
        && content.kind === 'Field'
        && content.selectionSet != null
        && totalElements != null) {
        const contentContent = content.selectionSet.selections.find(field => field.kind === 'Field' && field.name.value === 'content' && Array.isArray(field.selectionSet?.selections));
        const highlightFields = content.selectionSet.selections.find(field => field.kind === 'Field' && field.name.value === 'highlightFields');
        // unpack search wrapper
        if (contentContent != null
            && contentContent.kind === 'Field'
            && contentContent.selectionSet != null
            && highlightFields != null) {
            return contentContent.selectionSet.selections;
        }
        return content.selectionSet.selections;
    }
    return fields;
}
exports.unpackPaginationFields = unpackPaginationFields;
//# sourceMappingURL=unpackPaginationFields.js.map