"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unpackPaginationType = void 0;
const graphql_1 = require("graphql");
function unpackPaginationType(type, schema) {
    if (type.getFields()['content'] && type.getFields()['totalElements']) {
        const entityContentType = schema.getTypeMap()[(0, graphql_1.getNamedType)(type.getFields()['content'].type).toString()];
        if (!(0, graphql_1.isInputObjectType)(entityContentType) && !(0, graphql_1.isObjectType)(entityContentType)) {
            throw new Error(`Type ${entityContentType} does not contain fields. Are you sure it isn't a scalar?`);
        }
        // unpack search wrapper
        if (entityContentType.getFields()['content'] && entityContentType.getFields()['highlightFields']) {
            const entitySearchContentType = schema.getTypeMap()[(0, graphql_1.getNamedType)(entityContentType.getFields()['content'].type).toString()];
            if (!(0, graphql_1.isInputObjectType)(entitySearchContentType) && !(0, graphql_1.isObjectType)(entitySearchContentType)) {
                throw new Error(`Type ${entitySearchContentType} does not contain fields. Are you sure it isn't a scalar?`);
            }
            return entitySearchContentType;
        }
        return entityContentType;
    }
    return type;
}
exports.unpackPaginationType = unpackPaginationType;
//# sourceMappingURL=unpackPaginationType.js.map