"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.templateUtilities = void 0;
const to_fat_snake_case_1 = require("../../../util/to-fat-snake-case");
const utils_1 = require("../../../../common/utils");
const dollars_to_underscores_1 = require("../../../util/dollars-to-underscores");
const fat_snake_to_normal_1 = require("../../../util/fat-snake-to-normal");
const fat_snake_to_pascal_1 = require("../../../util/fat-snake-to-pascal");
const change_case_1 = require("change-case");
const composeDisplayNameFunctionName_1 = require("../../writing/pieces/display-name/composeDisplayNameFunctionName");
const NUMBER_TYPES = ['Int', 'Float', 'BigInteger', 'Long', 'BigDecimal'];
/**
 * You can add this to your TemplateModel if you want to use these utilities inside your
 * template.
 */
exports.templateUtilities = {
    toFatSnakeCase: to_fat_snake_case_1.toFatSnakeCase,
    unCapitalizeFirst: utils_1.unCapitalizeFirst,
    dollarsToUnderscores: dollars_to_underscores_1.dollarsToUnderscores,
    splitByCapitalLetter: utils_1.splitByCapitalLetter,
    capitalizeFirst: utils_1.capitalizeFirst,
    fatSnakeToNormal: fat_snake_to_normal_1.fatSnakeToNormal,
    fatSnakeToPascal: fat_snake_to_pascal_1.fatSnakeToPascal,
    pascalCase: change_case_1.pascalCase,
    composeDisplayNameFunctionName: composeDisplayNameFunctionName_1.composeDisplayNameFunctionName,
    constantCase: change_case_1.constantCase,
    capitalCase: change_case_1.capitalCase,
    isNumberType,
};
function isNumberType(type) {
    return NUMBER_TYPES.some(t => t === type);
}
//# sourceMappingURL=util.js.map