"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeDisplayNameFunction = void 0;
const tslib_1 = require("tslib");
const fs_1 = tslib_1.__importDefault(require("fs"));
const path_1 = tslib_1.__importDefault(require("path"));
const util_1 = require("../../../template-model/pieces/util");
const composeDisplayNameFunctionName_1 = require("./composeDisplayNameFunctionName");
async function writeDisplayNameFunction({ gen, entityName, attributes, dirShift, idAttrName = 'id' }) {
    const functionPath = getFunctionPath(entityName, gen.destinationPath(), dirShift);
    if (fs_1.default.existsSync(functionPath)) {
        return;
    }
    const templatePath = path_1.default.resolve(__dirname, 'template/DisplayNameFunction.ejs');
    const templateModel = {
        attributes,
        entityName,
        idAttrName,
        ...util_1.templateUtilities
    };
    await gen.fs.copyTpl(templatePath, functionPath, templateModel);
}
exports.writeDisplayNameFunction = writeDisplayNameFunction;
function getFunctionPath(entityName, componentDestPath, dirShift) {
    return path_1.default.join(componentDestPath, dirShift ?? '', 'core', 'display-name', (0, composeDisplayNameFunctionName_1.composeDisplayNameFunctionName)(entityName) + '.ts');
}
//# sourceMappingURL=writeDisplayNameFunction.js.map