"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeDisplayNameFunctionsForRelations = void 0;
const writeDisplayNameFunction_1 = require("./writeDisplayNameFunction");
async function writeDisplayNameFunctionsForRelations(gen, attributes, relDirShift) {
    // Write getXXXDisplayName() functions for relation attributes
    const relationAttrs = attributes
        .filter(attr => attr.isSingleRelationField || attr.isMultiRelationField);
    for (const relation of relationAttrs) {
        if (relation.type == null || relation.nestedAttributes == null) {
            throw new Error('Entity name not found');
        }
        await (0, writeDisplayNameFunction_1.writeDisplayNameFunction)({
            gen,
            entityName: relation.type,
            attributes: relation.nestedAttributes,
            dirShift: relDirShift,
        });
    }
}
exports.writeDisplayNameFunctionsForRelations = writeDisplayNameFunctionsForRelations;
//# sourceMappingURL=writeDisplayNameFunctionsForRelations.js.map