"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseExpression = void 0;
const tslib_1 = require("tslib");
const jscodeshift_1 = tslib_1.__importDefault(require("jscodeshift"));
const tsxParser = jscodeshift_1.default.withParser('tsx');
/**
 * @param jsExpression - js code which could be value of variable
 *
 * @returns - Ast from jsExpression
 * */
function parseExpression(jsExpression) {
    const astOfExpression = tsxParser(`const value = ${jsExpression};`)
        .findVariableDeclarators('value')
        .paths()[0]
        .value
        .init;
    if (astOfExpression == null)
        throw new Error('Error while parsing js expression');
    return astOfExpression;
}
exports.parseExpression = parseExpression;
//# sourceMappingURL=parseExpression.js.map