"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addDeps = exports.removeDeps = exports.updateNpmDeps = void 0;
/**
 * Removes dependencies from package.json file.
 * Doesn't uninstall dependencies.
 *
 * @param gen
 * @param prevDeps
 * @param newDeps
 */
async function updateNpmDeps(gen, prevDeps, newDeps) {
    const packageJsonPath = gen.destinationPath('./package.json');
    const source = await gen.fs.readJSON(packageJsonPath);
    const output = JSON.parse(JSON.stringify(source));
    removeDeps(output, prevDeps);
    addDeps(output, newDeps);
    if (JSON.stringify(source) !== JSON.stringify(output)) {
        await gen.fs.writeJSON(packageJsonPath, output);
    }
}
exports.updateNpmDeps = updateNpmDeps;
function removeDeps(packageJson, deps) {
    console.log("removeDeps", deps);
    for (const dep of deps) {
        delete packageJson.dependencies[dep];
    }
}
exports.removeDeps = removeDeps;
function addDeps(packageJson, deps) {
    console.log("addDeps", deps);
    Object.entries(deps).forEach(([propName, propVal]) => packageJson.dependencies[propName] = propVal);
}
exports.addDeps = addDeps;
//# sourceMappingURL=updateNpmDeps.js.map