"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.composeImportForAppTsx = void 0;
const tslib_1 = require("tslib");
const path_1 = tslib_1.__importDefault(require("path"));
const utils_1 = require("../../../../../common/utils");
function composeImportForAppTsx(componentImportPath, componentName) {
    // do not create relative import, if imported from package (i.e @amplicode/my-addon)
    if (componentImportPath.startsWith("@")) {
        return componentImportPath;
    }
    const result = path_1.default.posix.join("..", (0, utils_1.normalizeImportRelativePath)(componentImportPath, true), componentName);
    // In case that we add import to file App.tsx, which located in `app` directory
    // we can shorten import path started from "../app" to "./"
    return result.replace(/^..\/app\//, './');
}
exports.composeImportForAppTsx = composeImportForAppTsx;
//# sourceMappingURL=composeImportForAppTsx.js.map