"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAdminUiTagChildren = void 0;
function getAdminUiTagChildren(adminUi) {
    if (adminUi == null) {
        console.error(`getAdminUiTagChildren: no 'AdminUI' tag found`);
        throw new Error(`No 'AdminUI' tag found in input`);
    }
    if (adminUi.paths().length != 1) {
        console.error(`getAdminUiTagChildren: only one 'AdminUI' should be in input`);
        throw new Error(`Only one 'AdminUI' tag should be in input`);
    }
    const children = adminUi.nodes()[0].children;
    if (children == null) {
        console.error(`getAdminUiTagChildren: 'children' of 'AdminUI' is undefined in input`);
        throw new Error(`Parsing 'AdminUI' tag failed - 'children' is undefined`);
    }
    return children;
}
exports.getAdminUiTagChildren = getAdminUiTagChildren;
//# sourceMappingURL=getAdminUiTagChildren.js.map