"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMenuTagChildren = void 0;
function getMenuTagChildren(appMenuAST) {
    const menu = appMenuAST.findJSXElements("Menu");
    if (menu == null) {
        console.error(`getMenuTagChildren: no 'Menu' tag found in input`);
        throw new Error(`No 'Menu' tag found in input`);
    }
    if (menu.paths().length != 1) {
        console.error(`getMenuTagChildren: only one 'Menu' tag should be in input`);
        throw new Error(`Only one 'Menu' tag should be in input`);
    }
    const children = menu.nodes()[0].children;
    if (children == null) {
        console.error(`getMenuTagChildren: 'children' is undefined in input`);
        throw new Error(`Parsing 'Menu' tag failed - 'children' is undefined`);
    }
    return children;
}
exports.getMenuTagChildren = getMenuTagChildren;
//# sourceMappingURL=getMenuTagChildren.js.map