"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const chai_1 = require("chai");
const removeVarExport_1 = require("./removeVarExport");
const jscodeshift_1 = tslib_1.__importDefault(require("jscodeshift"));
const toSource_1 = require("../../jsCodeShift/toSource");
describe('removeVar()', () => {
    it('removes variable from ts file', () => {
        const tsParser = jscodeshift_1.default.withParser('ts');
        const ast = tsParser(file);
        (0, removeVarExport_1.removeVarExport)(ast, 'LOGIN_URI');
        (0, removeVarExport_1.removeVarExport)(ast, 'LOGOUT_URI');
        (0, removeVarExport_1.removeVarExport)(ast, 'REQUEST_SAME_ORIGIN');
        (0, removeVarExport_1.removeVarExport)(ast, 'DEV_LOGIN');
        (0, removeVarExport_1.removeVarExport)(ast, 'DEV_PASSWORD');
        (0, chai_1.expect)((0, toSource_1.toSource)(ast)).to.eq(fileModified);
    });
});
const file = `
export const GRAPHQL_URI = import.meta.env.VITE_GRAPHQL_URI ?? "/graphql";
export const LOGIN_URI = import.meta.env.VITE_LOGIN_URI ?? "/login";
export const LOGOUT_URI = import.meta.env.VITE_LOGOUT_URI ?? "/logout";
export const REQUEST_SAME_ORIGIN =
  import.meta.env.VITE_REQUEST_SAME_ORIGIN ?? true;
export const DEV_LOGIN = import.meta.env.VITE_DEV_LOGIN ?? "admin";
export const DEV_PASSWORD = import.meta.env.VITE_DEV_PASSWORD ?? "admin";
`;
const fileModified = `
export const GRAPHQL_URI = import.meta.env.VITE_GRAPHQL_URI ?? "/graphql";
`;
//# sourceMappingURL=removeVar.test.js.map