"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeVarExport = exports.removeVarExportInFile = void 0;
const tslib_1 = require("tslib");
const jscodeshift_1 = tslib_1.__importDefault(require("jscodeshift"));
const toSource_1 = require("../../jsCodeShift/toSource");
async function removeVarExportInFile(gen, file, variableName) {
    const filePath = gen.destinationPath(file);
    const source = gen.fs.read(filePath);
    const tsParser = jscodeshift_1.default.withParser('ts');
    const ast = tsParser(source);
    removeVarExport(ast, variableName);
    const output = (0, toSource_1.toSource)(ast);
    await gen.fs.write(filePath, output);
}
exports.removeVarExportInFile = removeVarExportInFile;
function removeVarExport(ast, variableName) {
    ast.find(jscodeshift_1.default.ExportNamedDeclaration, (node) => node?.declaration?.declarations?.[0]?.id?.name === variableName)
        .remove();
}
exports.removeVarExport = removeVarExport;
//# sourceMappingURL=removeVarExport.js.map