"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const replaceEnvVarValue_1 = require("./replaceEnvVarValue");
const ReplacementTargetNotFoundError_1 = require("./ReplacementTargetNotFoundError");
describe('replaceEnvVarValue()', () => {
    it('replaces env variable value when it is found', () => {
        const output = (0, replaceEnvVarValue_1.replaceEnvVarValue)(envDev, 'VITE_LOGIN_URI', '/oauth2/authorize');
        (0, chai_1.expect)(output).to.eq(envDevModified);
    });
    it('throws ReplacementTargetNotFoundError when env variable is not found', () => {
        (0, chai_1.expect)(replaceEnvVarValue_1.replaceEnvVarValue.bind(undefined, envDevFailing, 'VITE_LOGIN_URI', '/oauth2/authorize'))
            .to.throw(ReplacementTargetNotFoundError_1.ReplacementTargetNotFoundError);
    });
});
const envDev = `
VITE_GRAPHQL_URI=/graphql
VITE_LOGIN_URI=/login
VITE_LOGOUT_URI=/logout
VITE_REQUEST_SAME_ORIGIN=true
VITE_DEV_LOGIN=admin
VITE_DEV_PASSWORD=admin
`;
const envDevModified = `
VITE_GRAPHQL_URI=/graphql
VITE_LOGIN_URI=/oauth2/authorize
VITE_LOGOUT_URI=/logout
VITE_REQUEST_SAME_ORIGIN=true
VITE_DEV_LOGIN=admin
VITE_DEV_PASSWORD=admin
`;
const envDevFailing = `
VITE_GRAPHQL_URI=/graphql
VITE_LOGOUT_URI=/logout
VITE_REQUEST_SAME_ORIGIN=true
VITE_DEV_LOGIN=admin
VITE_DEV_PASSWORD=admin
`;
//# sourceMappingURL=replaceEnvVarValue.test.js.map