import { OptionConfig } from "yeoman-generator";
export type OptionsConfig = {
    [optionName: string]: OptionConfig;
};
interface CommanderOptionInfo {
    pattern: string;
    description?: string;
}
export interface CommonGenerationOptions {
    dest?: string;
    model?: string;
    answers?: string;
    verbose?: boolean;
    templateOverride?: string;
}
export declare const commonGenerationOptionsConfig: OptionsConfig;
export declare const componentOptionsConfig: OptionsConfig;
/**
 * Convert 'OptionsConfig' object to array of items that could be used in generator cli api
 * @param optionsConfig
 */
export declare function extractAvailableOptions(optionsConfig?: OptionsConfig): CommanderOptionInfo[];
/**
 * Pick  option as object from command
 *
 * @param cmd list of options from cli command
 * @param availableOptions options config
 */
export declare function pickOptions(cmd: {
    [key: string]: any;
}, availableOptions?: OptionsConfig): {
    [key: string]: string | boolean | Array<Record<string, unknown>>;
};
export {};
