import { StudioTemplateProperty } from "./studio/studio-model";
import { Answers } from "yeoman-generator";
import { ProjectModel } from './model/cuba-model';
export type ObjectChoice = {
    name: string;
    value: any;
    short?: string;
};
export type Choice = string | ObjectChoice;
interface Question {
    type: QuestionType;
    name: string;
    message: string;
    choices?: Choice[] | ((previousAnswers: Answers) => Choice[]);
    source?: (answers: Answers, input: string) => Promise<Choice[]>;
}
export declare const enum QuestionType {
    input = "input",
    confirm = "confirm",
    list = "list",
    rawlist = "rawlist",
    expand = "expand",
    checkbox = "checkbox",
    password = "password",
    editor = "editor",
    autocomplete = "autocomplete"
}
export declare function fromStudioProperty(prop: StudioTemplateProperty, projectModel?: ProjectModel): Question;
export declare function fromStudioProperties(props: StudioTemplateProperty[], projectModel?: ProjectModel): Question[];
export {};
