"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeAddonWorkspace = void 0;
const tslib_1 = require("tslib");
const raWriteSchema_1 = require("../common/raWriteSchema");
const path_1 = tslib_1.__importDefault(require("path"));
async function writeAddonWorkspace(templateModel, gen) {
    gen.log(`Generating to ${gen.destinationPath()}`);
    const workspaceDirName = `${templateModel.addonBackendName}-frontend`;
    const workspaceRootPath = gen.destinationPath(workspaceDirName);
    gen.fs.copyTpl(gen.templatePath(`*`), workspaceRootPath, templateModel, undefined, { globOptions: { dot: true } });
    // copy from `packages/addon` to folder with real addon name, i.e. `packages/addon-email-templates`
    gen.fs.copyTpl(gen.templatePath('packages', 'addon', '**'), path_1.default.join(workspaceRootPath, 'packages', templateModel.addonFrontendName), templateModel, undefined, { globOptions: { dot: true } });
    gen.fs.move(path_1.default.join(workspaceRootPath, '_gitignore'), path_1.default.join(workspaceRootPath, '.gitignore'));
    (0, raWriteSchema_1.raWriteSchema)(gen, templateModel, [workspaceDirName, 'packages', templateModel.addonFrontendName]);
}
exports.writeAddonWorkspace = writeAddonWorkspace;
//# sourceMappingURL=write.js.map