"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFrontendComponent = exports.params = exports.options = exports.generator = exports.name = exports.AppGenerator = void 0;
const tslib_1 = require("tslib");
const ForceUpdateYeomanGenerator_1 = require("../../react-typescript/ForceUpdateYeomanGenerator");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = tslib_1.__importDefault(require("path"));
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeCommonOptionsConfig; } });
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.appQuestions; } });
const template_model_1 = require("./template-model");
const write_1 = require("./write");
class AppGenerator extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.appQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveTemplateModel,
                write: write_1.writeApp
            }
        }, this);
    }
}
exports.AppGenerator = AppGenerator;
exports.generator = AppGenerator;
const name = 'app';
exports.name = name;
const isFrontendComponent = false;
exports.isFrontendComponent = isFrontendComponent;
//# sourceMappingURL=index.js.map