import { FunctionField, FunctionFieldProps, RaRecord } from "react-admin";
import { renderDate } from "../../format/renderDate";
import get from "lodash/get";

export const DateField = (props: Omit<FunctionFieldProps, "render">) => {
  const { source } = props;
  if (source == null) {
    return null;
  }

  return <FunctionField render={(record: RaRecord) => renderDate(get(record, source))} {...props} />;
};
