import { FunctionField, FunctionFieldProps, RaRecord } from "react-admin";
import { renderLocalTime } from "../../format/renderLocalTime";
import get from "lodash/get";

export const LocalTimeField = (props: Omit<FunctionFieldProps, "render">) => {
  const { source } = props;
  if (source == null) {
    return null;
  }

  return (
    <FunctionField render={(record: RaRecord) => renderLocalTime(get(record, source))} {...props} />
  );
};
