"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.appendAddonComponentExportsToIndexTs = void 0;
const tslib_1 = require("tslib");
const node_path_1 = tslib_1.__importDefault(require("node:path"));
const node_fs_1 = tslib_1.__importDefault(require("node:fs"));
const recordRepresentationFunctionPath_1 = require("./common/recordRepresentation/recordRepresentationFunctionPath");
function appendAddonComponentExportsToIndexTs(addonPaths, componentNames, entityName, attributes) {
    componentNames.forEach(componentName => {
        // we need to use exact `/` slash in imports
        const componentImportPath = addonPaths.addonRelativeDestPath.replaceAll(node_path_1.default.sep, "/");
        node_fs_1.default.appendFileSync(addonPaths.addonIndexFilePath, `export * from "./${componentImportPath}/${componentName}";\n`);
    });
    if (entityName != null) {
        const recordRepImportPath = `${(0, recordRepresentationFunctionPath_1.recordRepresentationFunctionPath)('../src/', entityName)}`;
        const indexTs = node_fs_1.default.readFileSync(addonPaths.addonIndexFilePath, "utf-8");
        if (!indexTs.includes(recordRepImportPath)) {
            node_fs_1.default.appendFileSync(addonPaths.addonIndexFilePath, `export * from "./${recordRepImportPath}";\n`);
        }
        const relationAttrs = attributes
            .filter((attr) => attr.isSingleRelationField || attr.isMultiRelationField);
        relationAttrs.forEach((relation) => {
            const relationRecordRepImportPath = `${(0, recordRepresentationFunctionPath_1.recordRepresentationFunctionPath)('../src/', relation.type)}`;
            if (!indexTs.includes(relationRecordRepImportPath)) {
                node_fs_1.default.appendFileSync(addonPaths.addonIndexFilePath, `export * from "./${relationRecordRepImportPath}";\n`);
            }
        });
    }
}
exports.appendAddonComponentExportsToIndexTs = appendAddonComponentExportsToIndexTs;
//# sourceMappingURL=appendAddonComponentExportsToIndexTs.js.map