"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFrontendComponent = exports.description = exports.options = exports.generator = exports.name = exports.AuthFormLogin = void 0;
const tslib_1 = require("tslib");
const ForceUpdateYeomanGenerator_1 = require("../../react-typescript/ForceUpdateYeomanGenerator");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeCommonOptionsConfig; } });
const path_1 = tslib_1.__importDefault(require("path"));
const write_1 = require("./write");
const raResetAuth_1 = require("../common/auth/raResetAuth");
class AuthFormLogin extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async cleanup() {
        this.log("auth-form-login: perform auth cleanup before generation");
        const dest = this.options.dest;
        const rootPath = path_1.default.isAbsolute(dest) ? dest : path_1.default.join(this.destinationRoot(), dest);
        await (0, raResetAuth_1.raResetAuth)(rootPath);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            stages: {
                write: write_1.writeAuthFormLogin
            }
        }, this);
    }
}
exports.AuthFormLogin = AuthFormLogin;
exports.generator = AuthFormLogin;
const name = 'auth-form-login';
exports.name = name;
const description = 'Form login';
exports.description = description;
const isFrontendComponent = false;
exports.isFrontendComponent = isFrontendComponent;
//# sourceMappingURL=index.js.map