"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFrontendComponent = exports.description = exports.options = exports.generator = exports.name = exports.Auth_OAuth2_Keycloak_Stateful = void 0;
const tslib_1 = require("tslib");
const ForceUpdateYeomanGenerator_1 = require("../../react-typescript/ForceUpdateYeomanGenerator");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeCommonOptionsConfig; } });
const raResetAuth_1 = require("../common/auth/raResetAuth");
const path_1 = tslib_1.__importDefault(require("path"));
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const write_1 = require("./write");
class Auth_OAuth2_Keycloak_Stateful extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async cleanup() {
        this.log("auth-oauth2-keycloak-stateful: perform auth cleanup before generation");
        const dest = this.options.dest;
        const rootPath = path_1.default.isAbsolute(dest) ? dest : path_1.default.join(this.destinationRoot(), dest);
        await (0, raResetAuth_1.raResetAuth)(rootPath);
    }
    async generate() {
        this.log("auth-oauth2-keycloak-stateful: generate");
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            stages: {
                write: write_1.write_Auth_OAuth2_Keycloak_Stateful
            }
        }, this);
    }
}
exports.Auth_OAuth2_Keycloak_Stateful = Auth_OAuth2_Keycloak_Stateful;
exports.generator = Auth_OAuth2_Keycloak_Stateful;
const name = 'auth-oauth2-keycloak-stateful';
exports.name = name;
const description = 'OAuth2.0 with Keycloak (Stateful)';
exports.description = description;
const isFrontendComponent = false;
exports.isFrontendComponent = isFrontendComponent;
//# sourceMappingURL=index.js.map