"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.index = exports.icon = exports.description = exports.caption = exports.params = exports.options = exports.generator = exports.name = exports.Blank = void 0;
const tslib_1 = require("tslib");
const ForceUpdateYeomanGenerator_1 = require("../../react-typescript/ForceUpdateYeomanGenerator");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = tslib_1.__importDefault(require("path"));
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.blankQuestions; } });
const template_model_1 = require("./template-model");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeComponentOptionsConfig; } });
const write_1 = require("./write");
class Blank extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.blankQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveBlankTemplateModel,
                write: write_1.writeBlank
            }
        }, this);
    }
}
exports.Blank = Blank;
exports.generator = Blank;
const name = 'blank';
exports.name = name;
const caption = 'Blank Screen';
exports.caption = caption;
const description = 'Empty screen template';
exports.description = description;
const icon = 'blank.svg';
exports.icon = icon;
const index = 0;
exports.index = index;
//# sourceMappingURL=index.js.map