"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deriveBlankTemplateModel = void 0;
const BaseTemplateModel_1 = require("../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel");
const reactAdminUtilModel_1 = require("../common/reactAdminUtilModel");
const utils_1 = require("../../../common/utils");
const deriveBlankTemplateModel = async (options, answers, _schema) => {
    const { componentName, shouldAddToMenu, route, skipTestGeneration } = answers;
    // add check that 'route' is set, later automatically check of required answers should be added
    if ((0, utils_1.isBlank)(route)) {
        throw new Error(`Blank screen generation failed. Route should be set.`);
    }
    return {
        ...BaseTemplateModel_1.baseTemplateModel,
        ...reactAdminUtilModel_1.reactAdminUtilModel,
        relDirShift: (0, utils_1.normalizeImportRelativePath)(options.dirShift),
        route,
        componentName,
        shouldAddToMenu,
        skipTestGeneration: skipTestGeneration != null && skipTestGeneration
    };
};
exports.deriveBlankTemplateModel = deriveBlankTemplateModel;
//# sourceMappingURL=template-model.js.map