export type CamundaComponentType = "textfield" | "textarea" | "number" | "datetime" | "checkbox" | "taglist" | "select" | "checklist" | "radio" | "group" | "spacer" | "text" | "image" | "button";
export type CamundaComponentLayout = {
    row: string;
    columns?: number | null;
};
export type CamundaComponentValue = {
    label: string;
    value: string;
};
export type CamundaComponentSubtype = "datetime" | "date" | "time";
export type CamundaComponent = {
    groupEnd?: boolean;
    groupStart?: boolean;
    groupLabel?: string;
    showOutline?: boolean;
    label: string;
    type: CamundaComponentType;
    subtype?: CamundaComponentSubtype;
    id: string;
    key: string;
    description?: string;
    defaultValue?: string | number;
    layout: CamundaComponentLayout;
    validate?: {
        validationType?: "email";
        required?: boolean;
        pattern?: string;
        min?: number;
        max?: number;
        maxLength?: number;
        minLength?: number;
    };
    readonly?: boolean;
    disabled?: boolean;
    values?: CamundaComponentValue[];
    decimalDigits?: number;
    increment?: string;
    components?: CamundaComponent[];
    disallowPassedDates?: boolean;
    use24h?: boolean;
    timeInterval?: number;
    timeLabel?: string;
    dateLabel?: string;
    action?: "reset" | "submit";
};
