"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseDateDescriptor = void 0;
function parseDateDescriptor(desc) {
    const { key: source, description: helperText, readonly: readOnly, disabled, disallowPassedDates, timeLabel, dateLabel, validate, } = desc;
    return {
        source,
        disablePast: disallowPassedDates ?? false,
        readOnly: readOnly ?? false,
        // defaultValue, TODO - not found in camunda-frontend component
        disabled: disabled ?? false,
        helperText,
        label: `${dateLabel || ""} ${timeLabel || ""}`,
        validation: { required: validate?.required ?? false },
    };
}
exports.parseDateDescriptor = parseDateDescriptor;
//# sourceMappingURL=parseDateDescriptor.js.map