"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseDateTimeDescriptor = void 0;
function parseDateTimeDescriptor(desc) {
    const { key: source, description: helperText, readonly: readOnly, disabled, disallowPassedDates, use24h, timeInterval, timeLabel, dateLabel, validate, } = desc;
    return {
        source,
        label: `${dateLabel || ""} ${timeLabel || ""}`,
        helperText,
        // defaultValue, TODO - not found in camunda-frontend component
        readOnly: readOnly ?? false,
        disabled: disabled ?? false,
        disablePast: disallowPassedDates ?? false,
        minutesStep: timeInterval,
        ampm: !use24h,
        ampmInClock: !use24h,
        validation: { required: validate?.required ?? false },
    };
}
exports.parseDateTimeDescriptor = parseDateTimeDescriptor;
//# sourceMappingURL=parseDateTimeDescriptor.js.map