"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseNumberDescriptor = void 0;
function parseNumberDescriptor(desc) {
    const { key: source, label, description: helperText, readonly: readOnly, disabled, defaultValue, decimalDigits, increment: step, validate, } = desc;
    let validation = {};
    if (validate != null) {
        const { required, max, min, } = validate;
        validation = {
            required,
            maxValue: max,
            minValue: min,
        };
    }
    return {
        source,
        label,
        helperText,
        defaultValue,
        readOnly: readOnly ?? false,
        disabled: disabled ?? false,
        decimalDigits: decimalDigits ?? 0,
        step: step ?? 1,
        ...{ validation }
    };
}
exports.parseNumberDescriptor = parseNumberDescriptor;
//# sourceMappingURL=parseNumberDescriptor.js.map