"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseRadioButtonGroupDescriptor = void 0;
function parseRadioButtonGroupDescriptor(desc) {
    const { key: source, label, description: helperText, readonly: readOnly, disabled, defaultValue, values, validate, } = desc;
    return {
        source,
        choices: values ?? [],
        defaultValue,
        optionText: "label",
        optionValue: "value",
        disabled: disabled ?? false,
        helperText,
        label,
        readOnly: readOnly ?? false,
        validation: { required: validate?.required ?? false },
    };
}
exports.parseRadioButtonGroupDescriptor = parseRadioButtonGroupDescriptor;
//# sourceMappingURL=parseRadioButtonGroupDescriptor.js.map