"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseTextAreaDescriptor = void 0;
function parseTextAreaDescriptor(desc) {
    const { key: source, label, description: helperText, readonly: readOnly, disabled, defaultValue, validate, } = desc;
    let validation = {};
    if (validate != null) {
        const { required, maxLength, minLength, } = validate;
        validation = {
            required,
            maxLength,
            minLength,
        };
    }
    return {
        source,
        label,
        helperText,
        defaultValue,
        readOnly: readOnly ?? false,
        disabled: disabled ?? false,
        ...{ validation }
    };
}
exports.parseTextAreaDescriptor = parseTextAreaDescriptor;
//# sourceMappingURL=parseTextAreaDescriptor.js.map