"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseTextFieldDescriptor = void 0;
const utils_1 = require("../../../../common/utils");
function parseTextFieldDescriptor(desc) {
    const { key: source, label, description: helperText, readonly: readOnly, disabled, defaultValue, validate, } = desc;
    let validation = {};
    if (validate != null) {
        const { required, validationType, pattern, maxLength, minLength, } = validate;
        validation = {
            required,
            email: validationType === "email",
            regex: (0, utils_1.isBlank)(pattern) ? undefined : pattern,
            maxLength,
            minLength,
        };
    }
    return {
        source,
        label,
        helperText,
        defaultValue,
        readOnly: readOnly ?? false,
        disabled: disabled ?? false,
        ...{ validation }
    };
}
exports.parseTextFieldDescriptor = parseTextFieldDescriptor;
//# sourceMappingURL=parseTextFieldDescriptor.js.map