"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseTimeDescriptor = void 0;
function parseTimeDescriptor(desc) {
    const { key: source, description: helperText, readonly: readOnly, disabled, disallowPassedDates, use24h, timeInterval, timeLabel, dateLabel, validate, } = desc;
    return {
        source,
        disablePast: disallowPassedDates ?? false,
        minutesStep: timeInterval,
        ampm: !use24h,
        ampmInClock: !use24h,
        readOnly: readOnly ?? false,
        // defaultValue, TODO - not found in camunda-frontend component
        disabled: disabled ?? false,
        helperText,
        label: `${dateLabel || ""} ${timeLabel || ""}`,
        validation: { required: validate?.required ?? false },
    };
}
exports.parseTimeDescriptor = parseTimeDescriptor;
//# sourceMappingURL=parseTimeDescriptor.js.map