import { AmplicodeTemplateModelStage } from "../../../building-blocks/pipelines/amplicodePipeline";
import { AmplicodeComponentOptions } from "../../../building-blocks/stages/options/pieces/amplicode";
import { CamundaFormAnswers } from "./answers";
import { BaseTemplateModel } from "../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel";
import { CamundaComponentSubtype, CamundaComponentType } from "./descriptors/CamundaComponent";
import { AutocompleteArrayInputProps, BooleanInputProps, CheckboxGroupInputProps, NumberInputProps, RadioButtonGroupInputProps, SelectInputProps, TextInputProps } from "react-admin";
import { OffsetDateTimeInputProps } from "./descriptors/parseDateTimeDescriptor";
import { OffsetTimeInputProps } from "./descriptors/parseTimeDescriptor";
import { DateInputProps } from "./descriptors/parseDateDescriptor";
export type ComponentModel = {
    type: CamundaComponentType;
    subtype?: CamundaComponentSubtype;
    props: BooleanInputProps | CheckboxGroupInputProps | TextInputProps | NumberInputProps | OffsetDateTimeInputProps | OffsetTimeInputProps | DateInputProps | SelectInputProps | RadioButtonGroupInputProps | AutocompleteArrayInputProps;
};
export type ButtonModel = {
    action: "submit" | "reset";
    label: string;
};
export type CamundaComponentValidation = {
    validation: {
        required?: boolean;
        email?: boolean;
        pattern?: string;
        maxLength?: number;
        minLength?: number;
        maxValue?: number;
        minValue?: number;
    };
};
export interface CamundaFormTemplateModel extends BaseTemplateModel {
    componentName: string;
    route: string;
    relDirShift: string;
    componentModelList: ComponentModel[];
    buttonModelList: ButtonModel[];
}
export declare const deriveCamundaFormTemplateModel: AmplicodeTemplateModelStage<AmplicodeComponentOptions, CamundaFormAnswers, CamundaFormTemplateModel>;
