"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deriveCamundaFormTemplateModel = void 0;
const BaseTemplateModel_1 = require("../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel");
const reactAdminUtilModel_1 = require("../common/reactAdminUtilModel");
const utils_1 = require("../../../common/utils");
const base64_1 = require("../../../building-blocks/util/base64");
const deriveComponentModelList_1 = require("./deriveComponentModelList");
const deriveCamundaFormTemplateModel = async (options, answers, _schema) => {
    const { componentName, route, formDescriptor, } = answers;
    // add check that 'route' is set, later automatically check of required answers should be added
    if ((0, utils_1.isBlank)(route)) {
        throw new Error(`Blank screen generation failed. Route should be set.`);
    }
    const formDescriptorObject = (0, base64_1.parseBase64Object)(formDescriptor);
    const componentModelList = (0, deriveComponentModelList_1.deriveComponentModelList)(formDescriptorObject.components);
    const buttonModelList = formDescriptorObject.components
        .filter((cmp) => cmp.type === "button")
        .map((cmp) => ({
        action: cmp.action,
        label: cmp.label,
    }));
    return {
        ...BaseTemplateModel_1.baseTemplateModel,
        ...reactAdminUtilModel_1.reactAdminUtilModel,
        relDirShift: (0, utils_1.normalizeImportRelativePath)(options.dirShift),
        route,
        componentName,
        componentModelList,
        buttonModelList,
    };
};
exports.deriveCamundaFormTemplateModel = deriveCamundaFormTemplateModel;
//# sourceMappingURL=template-model.js.map