"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deriveAddonScreenPaths = exports.deriveScreenPaths = void 0;
const tslib_1 = require("tslib");
const path_1 = tslib_1.__importDefault(require("path"));
function deriveScreenPaths(dest, relDirShift) {
    const srcPath = path_1.default.join(dest, relDirShift);
    const relativeDestPath = path_1.default.relative(srcPath, dest);
    const localeMessagesPath = path_1.default.join(srcPath, "core/i18n/messages");
    const appTsxPath = path_1.default.join(srcPath, 'app', 'App.tsx');
    const menuTsxPath = path_1.default.join(srcPath, 'app', 'menu', 'MainMenu.tsx');
    const result = {
        srcPath,
        destPath: dest,
        relativeDestPath,
        localeMessagesPath,
        appTsxPath,
        menuTsxPath
    };
    console.debug(`deriveScreenPaths: return '${JSON.stringify(result)}' \nfrom input dest '${dest}' and relDirShift '${relDirShift}'`);
    return result;
}
exports.deriveScreenPaths = deriveScreenPaths;
function deriveAddonScreenPaths(dest, relDirShift, sampleAppName = 'sample-app') {
    const addonSrcPath = path_1.default.join(dest, relDirShift);
    const addonRelativeDestPath = path_1.default.relative(addonSrcPath, dest);
    const sampleAppSrcPath = path_1.default.join(addonSrcPath, '..', '..', '..', sampleAppName, 'src');
    const result = {
        addonSrcPath,
        addonRelativeDestPath,
        screenDestPath: dest,
        addonI18NPath: path_1.default.join(addonSrcPath, 'addon', 'i18n', 'messages'),
        addonIndexFilePath: path_1.default.join(addonSrcPath, 'index.ts'),
        metadataFilePath: path_1.default.join(addonSrcPath, '..', 'amplicode.addon-metadata.json'),
        addonPackageJsonFilePath: path_1.default.join(addonSrcPath, '..', 'package.json'),
        sampleAppSrcPath,
        sampleAppMenuFilePath: path_1.default.join(sampleAppSrcPath, 'app', 'menu', 'MainMenu.tsx'),
        sampleAppAppFilePath: path_1.default.join(sampleAppSrcPath, 'app', 'App.tsx'),
        sampleAppI18nFilePath: path_1.default.join(sampleAppSrcPath, 'core', 'i18n', 'messages'),
    };
    console.debug(`deriveAddonScreenPaths: return '${JSON.stringify(result)}' \nfrom input dest '${dest}' and relDirShift '${relDirShift}'`);
    return result;
}
exports.deriveAddonScreenPaths = deriveAddonScreenPaths;
//# sourceMappingURL=generatorPaths.js.map