import { I18nMessages } from "../../../../building-blocks/stages/template-model/pieces/getI18nMessages";
import * as j from "jscodeshift";
/**
 * Take localeFileContent, parse it to jscodeshift object
 * then find variable with localeMessages by messagesVarName
 * then merge (add if message with such key not exist)  default i18n messages
 * with existing messages to locale file in file system
 *
 * @param localeFileContent - string version of locale file from generated app
 * @param messagesVarName - using to find variable with locale messages inside
 * @param defaultI18nMessages - set of default messages of entity, or other item
 * this messages has low priority in merge, and will be added in result set only if there is no
 * messages with such keys in localeFileContent
 * @returns localeFileContent with added default messages which was missed before
 */
export declare function mergeI18nMessagesWithLocaleFileContent(localeFileContent: string, messagesVarName: string, defaultI18nMessages: I18nMessages): string;
/**
 * Helper util for mergeI18nMessagesWithLocaleFileContent function
 * Existed messages in file with locale messages should be parsed to node for subsequent merge with new messages.
 * @param messages
 */
export declare function parseMessagesToNode(messages: Record<string, any>): j.ObjectExpression;
