"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reactAdminUtilModel = void 0;
const change_case_1 = require("change-case");
const recordRepresentationFunctionName_1 = require("./recordRepresentation/recordRepresentationFunctionName");
const recordRepresentationFunctionImport_1 = require("./recordRepresentation/recordRepresentationFunctionImport");
const NUMBER_TYPES = ['Int', 'Float', 'BigInteger', 'Long', 'BigDecimal'];
/**
 * You can add this to your TemplateModel if you want to use these utilities inside your
 * template.
 */
exports.reactAdminUtilModel = {
    pascalCase: change_case_1.pascalCase,
    constantCase: change_case_1.constantCase,
    capitalCase: change_case_1.capitalCase,
    recordRepresentationFunctionName: recordRepresentationFunctionName_1.recordRepresentationFunctionName,
    recordRepresentationFunctionImport: recordRepresentationFunctionImport_1.recordRepresentationFunctionImport,
    isNumberType,
    getFileAttributesWithDownloadUrlQuery: (attributes) => attributes.filter(attr => attr.isFileType && attr.fileProperties?.downloadUrlQueryName != null),
    getFileAttributesWithUploadUrlQuery: (attributes) => attributes.filter(attr => attr.isFileType && attr.fileProperties?.uploadUrlQueryName != null),
};
function isNumberType(type) {
    return NUMBER_TYPES.some(t => t === type);
}
//# sourceMappingURL=reactAdminUtilModel.js.map