"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeRecordRepresentationFunction = void 0;
const tslib_1 = require("tslib");
const fs_1 = tslib_1.__importDefault(require("fs"));
const path_1 = tslib_1.__importDefault(require("path"));
const reactAdminUtilModel_1 = require("../reactAdminUtilModel");
const recordRepresentationFunctionPath_1 = require("./recordRepresentationFunctionPath");
function writeRecordRepresentationFunction({ gen, entityName, attributes, dirShift, idAttrName = 'id', functionPath }) {
    functionPath = functionPath ??
        `${(0, recordRepresentationFunctionPath_1.recordRepresentationFunctionPath)(path_1.default.join(gen.destinationPath(), dirShift ?? ''), entityName)}.ts`;
    if (fs_1.default.existsSync(functionPath)) {
        // TODO throw error
        return;
    }
    const templatePath = path_1.default.resolve(__dirname, 'template/RecordRepresentationFunction.ejs');
    const templateModel = {
        attributes,
        entityName,
        idAttrName,
        ...reactAdminUtilModel_1.reactAdminUtilModel
    };
    gen.fs.copyTpl(templatePath, functionPath, templateModel);
    console.log(`writeRecordRepresentationFunction: write function for '${entityName}' to '${functionPath}'`);
}
exports.writeRecordRepresentationFunction = writeRecordRepresentationFunction;
//# sourceMappingURL=writeRecordRepresentationFunction.js.map