"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeRecordRepresentationFunctionsForRelations = void 0;
const writeRecordRepresentationFunction_1 = require("./writeRecordRepresentationFunction");
function writeRecordRepresentationFunctionsForRelations(gen, attributes, relDirShift, functionPath) {
    // Write getXXXRecordRepresentation() functions for relation attributes
    const relationAttrs = attributes
        .filter((attr) => attr.isSingleRelationField || attr.isMultiRelationField);
    for (const relation of relationAttrs) {
        if (relation.type == null || relation.nestedAttributes == null) {
            throw new Error('Entity name not found');
        }
        (0, writeRecordRepresentationFunction_1.writeRecordRepresentationFunction)({
            gen,
            entityName: relation.type,
            attributes: relation.nestedAttributes,
            dirShift: relDirShift,
            functionPath
        });
    }
}
exports.writeRecordRepresentationFunctionsForRelations = writeRecordRepresentationFunctionsForRelations;
//# sourceMappingURL=writeRecordRepresentationFunctionsForRelations.js.map