"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeResourceToMenu = void 0;
const tslib_1 = require("tslib");
const path_1 = tslib_1.__importDefault(require("path"));
const addResourceToMenu_1 = require("../../../building-blocks/stages/writing/pieces/screen/addResourceToMenu");
function writeResourceToMenu(gen, srcDir, entityName) {
    const appMenuPath = path_1.default.join(srcDir, 'app', 'menu', 'MainMenu.tsx');
    if (!gen.fs.exists(appMenuPath)) {
        gen.log(`Unable to add component to menu, app menu file not found in path '${appMenuPath}'`);
    }
    else {
        const appMenuContents = gen.fs.read(appMenuPath);
        const appMenuTransformed = (0, addResourceToMenu_1.addResourceToMenu)(appMenuContents, entityName);
        gen.fs.write(appMenuPath, appMenuTransformed);
        gen.log(`Menu item '${entityName}' added to menu in '${appMenuPath}'`);
    }
}
exports.writeResourceToMenu = writeResourceToMenu;
//# sourceMappingURL=writeResourceToMenu.js.map