"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeScreenToAdminUi = void 0;
const addScreenToAdminUi_1 = require("../../../building-blocks/stages/writing/pieces/screen/addScreenToAdminUi");
const recordRepresentationFunctionImport_1 = require("./recordRepresentation/recordRepresentationFunctionImport");
const composeImportForAppTsx_1 = require("../../../building-blocks/stages/writing/pieces/screen/composeImportForAppTsx");
function writeScreenToAdminUi(gen, screenPaths, entityName, screenName, screenType) {
    const appTsxFilePath = screenPaths.appTsxPath;
    if (!gen.fs.exists(appTsxFilePath)) {
        gen.log(`Unable to add screen to AdminUI, App.tsx file not found in path '${appTsxFilePath}'`);
    }
    else {
        const appContents = gen.fs.read(appTsxFilePath);
        const recordRepImport = screenPaths.recordRepresentationImport ?? (0, recordRepresentationFunctionImport_1.recordRepresentationFunctionImport)("..", entityName);
        const appTransformed = (0, addScreenToAdminUi_1.addScreenToAdminUi)(appContents, entityName, screenName, screenType, (0, composeImportForAppTsx_1.composeImportForAppTsx)(screenPaths.screenImportPath, screenName), recordRepImport);
        gen.fs.write(appTsxFilePath, appTransformed);
        gen.log(`Screen '${screenType}:${screenName}' added to AdminUI tag in '${appTsxFilePath}'`);
    }
}
exports.writeScreenToAdminUi = writeScreenToAdminUi;
//# sourceMappingURL=writeScreenToAdminUi.js.map