"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.entityEditorQuestions = void 0;
exports.entityEditorQuestions = [
    {
        caption: 'Query to load item',
        code: 'detailsQuery',
        propertyType: "GRAPHQL_QUERY" /* StudioTemplatePropertyType.GRAPHQL_QUERY */,
        required: true,
        step: {
            name: 'Entity Edit',
            order: '1'
        }
    },
    {
        caption: 'Mutation to create or update item',
        code: 'upsertMutation',
        propertyType: "GRAPHQL_MUTATION" /* StudioTemplatePropertyType.GRAPHQL_MUTATION */,
        required: false,
        relatedProperty: 'detailsQuery',
        step: {
            name: 'Entity Edit',
            order: '2'
        }
    },
    {
        caption: 'Create component name',
        code: 'createComponentName',
        propertyType: "POLYMER_COMPONENT_NAME" /* StudioTemplatePropertyType.POLYMER_COMPONENT_NAME */,
        defaultValue: 'Create',
        required: true,
        relatedProperty: 'detailsQuery',
        step: {
            name: 'Entity Edit',
            order: '3'
        }
    },
    {
        caption: 'Edit component name',
        code: 'editComponentName',
        propertyType: "POLYMER_COMPONENT_NAME" /* StudioTemplatePropertyType.POLYMER_COMPONENT_NAME */,
        defaultValue: 'Edit',
        required: true,
        relatedProperty: 'detailsQuery',
        step: {
            name: 'Entity Edit',
            order: '3'
        }
    },
    {
        caption: "Skip test generation",
        code: "skipTestGeneration",
        propertyType: "BOOLEAN" /* StudioTemplatePropertyType.BOOLEAN */,
        defaultValue: false,
        required: false,
        step: {
            name: 'Entity Edit',
            order: '3'
        }
    },
    {
        caption: "File upload and download options",
        code: "fileAttributesEditProperties",
        propertyType: "FILE_ATTRIBUTES_EDIT_PROPERTIES" /* StudioTemplatePropertyType.FILE_ATTRIBUTES_EDIT_PROPERTIES */,
        defaultValue: [],
        required: false,
        relatedProperties: ["detailsQuery", "upsertMutation"],
        step: {
            name: "Entity Edit",
            order: "3"
        }
    }
];
//# sourceMappingURL=answers.js.map