import { AmplicodeTemplateModelStage } from "../../../building-blocks/pipelines/amplicodePipeline";
import { AmplicodeComponentOptions } from "../../../building-blocks/stages/options/pieces/amplicode";
import { AdvancedEditorAnswers, FileAttributesEditPropertiesAnswer } from "./answers";
import { DocumentNode, GraphQLSchema } from "graphql";
import { BaseTemplateModel } from "../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel";
import { GqlAttributeModel } from "../../../building-blocks/stages/template-model/pieces/entity";
import { ReactAdminUtilModel } from "../common/reactAdminUtilModel";
import { I18nMessages } from "../../../building-blocks/stages/template-model/pieces/getI18nMessages";
export interface EntityEditorTemplateModel extends BaseTemplateModel, ReactAdminUtilModel, GraphQLCreateModel {
    createComponentName: string;
    editComponentName: string;
    caption: string;
    relDirShift: string;
    schema?: string;
    queryString: string;
    mutationString?: string;
    skipTestGeneration: boolean;
}
interface GraphQLCreateModel {
    queryName: string;
    idIsNotNull: boolean;
    mutationName?: string;
    entityName: string;
    attributes: GqlAttributeModel[];
    inputVariableName?: string;
    inputTypeName?: string;
    allAttributes: string[];
    i18nMessages: I18nMessages;
}
export declare const deriveEntityEditorTemplateModel: AmplicodeTemplateModelStage<AmplicodeComponentOptions, AdvancedEditorAnswers, EntityEditorTemplateModel>;
export declare function deriveGraphQLEditorModel(queryNode: DocumentNode, idField: string, schema?: GraphQLSchema, mutationNode?: DocumentNode, fileAttributesEditProperties?: FileAttributesEditPropertiesAnswer[]): GraphQLCreateModel;
export {};
