"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.entitySearchListQuestions = void 0;
exports.entitySearchListQuestions = [
    {
        caption: 'Search query to load items',
        code: 'listQuery',
        propertyType: "GRAPHQL_QUERY" /* StudioTemplatePropertyType.GRAPHQL_QUERY */,
        required: true,
        step: {
            name: 'Entity List',
            order: '1'
        }
    },
    {
        caption: 'Mutation to delete an item',
        code: 'deleteMutation',
        propertyType: "GRAPHQL_MUTATION" /* StudioTemplatePropertyType.GRAPHQL_MUTATION */,
        relatedProperty: 'listQuery',
        required: false,
        step: {
            name: 'Entity List',
            order: '2'
        }
    },
    {
        caption: 'Component name',
        code: 'componentName',
        propertyType: "POLYMER_COMPONENT_NAME" /* StudioTemplatePropertyType.POLYMER_COMPONENT_NAME */,
        relatedProperty: 'listQuery',
        defaultValue: 'List',
        required: true,
        step: {
            name: 'Entity List',
            order: '3'
        }
    },
    {
        caption: "Select argument for pagination",
        code: "paginationArgument",
        propertyType: "PAGINATION_ARGUMENT" /* StudioTemplatePropertyType.PAGINATION_ARGUMENT */,
        relatedProperty: "listQuery",
        required: true,
        defaultValue: 'page',
        step: {
            name: "Entity List",
            order: "3"
        }
    },
    {
        caption: "Skip test generation",
        code: "skipTestGeneration",
        propertyType: "BOOLEAN" /* StudioTemplatePropertyType.BOOLEAN */,
        defaultValue: false,
        required: false,
        step: {
            name: "Entity List",
            order: "3"
        }
    }
];
//# sourceMappingURL=answers.js.map