"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.index = exports.icon = exports.description = exports.caption = exports.params = exports.options = exports.generator = exports.name = exports.EntitySearchListGenerator = void 0;
const tslib_1 = require("tslib");
const ForceUpdateYeomanGenerator_1 = require("../../react-typescript/ForceUpdateYeomanGenerator");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeComponentOptionsConfig; } });
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = tslib_1.__importDefault(require("path"));
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.entitySearchListQuestions; } });
const template_model_1 = require("./template-model");
const write_1 = require("./write");
class EntitySearchListGenerator extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        // TODO refactor - not clear, not sure that we are using this
        const templateDir = path_1.default.join(__dirname, 'template');
        console.log('react-admin:entity-search-list generator, templateDir: ', templateDir);
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir,
            questions: answers_1.entitySearchListQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveAdvancedListModel,
                write: write_1.writeEntityList
            }
        }, this);
    }
}
exports.EntitySearchListGenerator = EntitySearchListGenerator;
exports.generator = EntitySearchListGenerator;
const name = 'entity-search-list';
exports.name = name;
const caption = 'Entity Search List';
exports.caption = caption;
const description = 'Set of entities displayed as list with search input';
exports.description = description;
const icon = 'list.svg';
exports.icon = icon;
const index = 33;
exports.index = index;
//# sourceMappingURL=index.js.map