import { AmplicodeComponentOptions } from "../../../building-blocks/stages/options/pieces/amplicode";
import { AmplicodeTemplateModelStage } from "../../../building-blocks/pipelines/amplicodePipeline";
import { BaseTemplateModel } from "../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel";
import { GqlAttributeModel } from "../../../building-blocks/stages/template-model/pieces/entity";
import { I18nMessages } from "../../../building-blocks/stages/template-model/pieces/getI18nMessages";
import { AdvancedListAnswers } from "./answers";
import { ReactAdminUtilModel } from "../common/reactAdminUtilModel";
export interface AdvancedSearchListModel extends BaseTemplateModel, ReactAdminUtilModel {
    componentName: string;
    itemComponentName?: string;
    entityName: string;
    i18nMessages: I18nMessages;
    queryName: string;
    queryString: string;
    deleteMutationName?: string;
    deleteMutationString?: string;
    withDeleteMutation: boolean;
    refetchQuery: string;
    attributes: GqlAttributeModel[];
    allAttributes: string[];
    withFilters: boolean;
    resultDataPath: string;
    withPagination: boolean;
    paginationArgument?: string;
    relDirShift: string;
    schema?: string;
    skipTestGeneration: boolean;
}
type AdvancedListTemplateModelStage = AmplicodeTemplateModelStage<AmplicodeComponentOptions, AdvancedListAnswers, AdvancedSearchListModel>;
export declare const deriveAdvancedListModel: AdvancedListTemplateModelStage;
export {};
