"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeEntityList = void 0;
const tslib_1 = require("tslib");
const mvp_1 = require("../../../building-blocks/stages/writing/pieces/mvp/mvp");
const path_1 = tslib_1.__importDefault(require("path"));
const writeResourceToMenu_1 = require("../common/writeResourceToMenu");
const writeScreenToAdminUi_1 = require("../common/writeScreenToAdminUi");
const generatorPaths_1 = require("../common/generatorPaths");
const writeRecordRepresentationFunctionsForRelations_1 = require("../common/recordRepresentation/writeRecordRepresentationFunctionsForRelations");
const writeRecordRepresentationFunction_1 = require("../common/recordRepresentation/writeRecordRepresentationFunction");
const mergeI18nMessagesWithLocaleFile_1 = require("../common/i18n/mergeI18nMessagesWithLocaleFile");
async function writeEntityList(templateModel, gen) {
    const { relDirShift, entityName, componentName, } = templateModel;
    // Write screen component
    await (0, mvp_1.writeAmplicodeComponent)(templateModel, gen, path_1.default.join(__dirname, 'template', `SearchListAdvanced.tsx.ejs`), false, false, !templateModel.skipTestGeneration);
    const { srcPath, appTsxPath, relativeDestPath, localeMessagesPath } = (0, generatorPaths_1.deriveScreenPaths)(gen.destinationRoot(), relDirShift);
    // Add menu item
    (0, writeResourceToMenu_1.writeResourceToMenu)(gen, srcPath, entityName);
    // Add screen to <AdminUI>
    (0, writeScreenToAdminUi_1.writeScreenToAdminUi)(gen, { appTsxPath, screenImportPath: relativeDestPath }, entityName, componentName, "list");
    await (0, writeRecordRepresentationFunction_1.writeRecordRepresentationFunction)({
        gen: gen,
        entityName: templateModel.entityName,
        attributes: templateModel.allAttributes,
        dirShift: templateModel.relDirShift
    });
    await (0, writeRecordRepresentationFunctionsForRelations_1.writeRecordRepresentationFunctionsForRelations)(gen, templateModel.attributes, templateModel.relDirShift);
    await (0, mergeI18nMessagesWithLocaleFile_1.mergeI18nMessagesWithLocaleFile)(localeMessagesPath, 'en', templateModel.i18nMessages);
    // TODO
    // writeGraphQLSchema(gen, templateModel, path.join('..', templateModel.relDirShift));
}
exports.writeEntityList = writeEntityList;
//# sourceMappingURL=write.js.map