"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.index = exports.icon = exports.description = exports.caption = exports.params = exports.options = exports.generator = exports.name = exports.EntityShow = void 0;
const tslib_1 = require("tslib");
const ForceUpdateYeomanGenerator_1 = require("../../react-typescript/ForceUpdateYeomanGenerator");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = tslib_1.__importDefault(require("path"));
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.entityShowQuestions; } });
const template_model_1 = require("./template-model");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeComponentOptionsConfig; } });
const write_1 = require("./write");
class EntityShow extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.entityShowQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveEntityShowTemplateModel,
                write: write_1.writeEntityShow
            }
        }, this);
    }
}
exports.EntityShow = EntityShow;
exports.generator = EntityShow;
const name = 'entity-show';
exports.name = name;
const caption = 'Entity Show';
exports.caption = caption;
const description = 'Show entity screen';
exports.description = description;
const icon = 'entity-details.svg';
exports.icon = icon;
const index = 40;
exports.index = index;
//# sourceMappingURL=index.js.map