import { AmplicodeTemplateModelStage } from "../../../building-blocks/pipelines/amplicodePipeline";
import { AmplicodeComponentOptions } from "../../../building-blocks/stages/options/pieces/amplicode";
import { AdvancedShowAnswers, FileAttributesShowPropertiesAnswer } from "./answers";
import { DocumentNode, GraphQLSchema } from "graphql";
import { BaseTemplateModel } from "../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel";
import { GqlAttributeModel } from "../../../building-blocks/stages/template-model/pieces/entity";
import { ReactAdminUtilModel } from "../common/reactAdminUtilModel";
import { I18nMessages } from "../../../building-blocks/stages/template-model/pieces/getI18nMessages";
export interface EntityShowTemplateModel extends BaseTemplateModel, ReactAdminUtilModel, GraphQLShowModel {
    showComponentName: string;
    caption: string;
    relDirShift: string;
    schema?: string;
    queryString: string;
    skipTestGeneration: boolean;
}
interface GraphQLShowModel {
    queryName: string;
    entityName: string;
    attributes: GqlAttributeModel[];
    allAttributes: string[];
    i18nMessages: I18nMessages;
}
export declare const deriveEntityShowTemplateModel: AmplicodeTemplateModelStage<AmplicodeComponentOptions, AdvancedShowAnswers, EntityShowTemplateModel>;
export declare function deriveGraphQLShowModel(queryNode: DocumentNode, idField: string, schema?: GraphQLSchema, fileAttributesShowProperties?: FileAttributesShowPropertiesAnswer[]): GraphQLShowModel;
export {};
