"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeEntityShow = void 0;
const tslib_1 = require("tslib");
const path_1 = tslib_1.__importDefault(require("path"));
const mvp_1 = require("../../../building-blocks/stages/writing/pieces/mvp/mvp");
const writeResourceToMenu_1 = require("../common/writeResourceToMenu");
const writeScreenToAdminUi_1 = require("../common/writeScreenToAdminUi");
const generatorPaths_1 = require("../common/generatorPaths");
const writeRecordRepresentationFunctionsForRelations_1 = require("../common/recordRepresentation/writeRecordRepresentationFunctionsForRelations");
const writeRecordRepresentationFunction_1 = require("../common/recordRepresentation/writeRecordRepresentationFunction");
const mergeI18nMessagesWithLocaleFile_1 = require("../common/i18n/mergeI18nMessagesWithLocaleFile");
async function writeEntityShow(templateModel, gen) {
    const { relDirShift, entityName, i18nMessages } = templateModel;
    await (0, mvp_1.writeAmplicodeComponent)({ componentName: templateModel.showComponentName, ...templateModel }, gen, path_1.default.join(__dirname, 'template', 'ShowAdvanced.tsx.ejs'), false, false, !templateModel.skipTestGeneration);
    const { srcPath, appTsxPath, relativeDestPath, localeMessagesPath } = (0, generatorPaths_1.deriveScreenPaths)(gen.destinationRoot(), relDirShift);
    // Add menu item
    (0, writeResourceToMenu_1.writeResourceToMenu)(gen, srcPath, entityName);
    // Add screens to <AdminUI> in App.tsx
    (0, writeScreenToAdminUi_1.writeScreenToAdminUi)(gen, { appTsxPath, screenImportPath: relativeDestPath }, entityName, templateModel.showComponentName, "show");
    await (0, writeRecordRepresentationFunction_1.writeRecordRepresentationFunction)({
        gen: gen,
        entityName: templateModel.entityName,
        attributes: templateModel.allAttributes,
        dirShift: templateModel.relDirShift
    });
    await (0, writeRecordRepresentationFunctionsForRelations_1.writeRecordRepresentationFunctionsForRelations)(gen, templateModel.attributes, templateModel.relDirShift);
    await (0, mergeI18nMessagesWithLocaleFile_1.mergeI18nMessagesWithLocaleFile)(localeMessagesPath, 'en', i18nMessages);
}
exports.writeEntityShow = writeEntityShow;
//# sourceMappingURL=write.js.map