"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFrontendComponent = exports.options = exports.generator = exports.name = exports.UpdateSchemaGenerator = void 0;
const tslib_1 = require("tslib");
const ForceUpdateYeomanGenerator_1 = require("../../react-typescript/ForceUpdateYeomanGenerator");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeCommonOptionsConfig; } });
const raWriteSchema_1 = require("../common/raWriteSchema");
const amplicodeGetGraphQLSchema_1 = require("../../../building-blocks/stages/graphql-schema/amplicodeGetGraphQLSchema");
const path_1 = tslib_1.__importDefault(require("path"));
const raPrintSchema_1 = require("../common/raPrintSchema");
class UpdateSchemaGenerator extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    // in case of simplification and performance,
    // we don't use 'amplicodePipeline' for utility generators, like this
    async generate() {
        // from defaultConfigureGenerator:
        const { dest } = this.options;
        if (dest != null) {
            this.destinationRoot(path_1.default.isAbsolute(dest)
                ? dest
                : path_1.default.join(this.destinationRoot(), dest));
        }
        // TODO need to be investigated, may be we can simplify this
        // Setting the generator's destinationRoot (which happens inside configureGenerator) will change the current working directory,
        // therefore we need to save the directory from which the generator command was invoked.
        const invocationDir = process.cwd();
        console.log(`react-admin:update-schema invocationDir is set to '${invocationDir}'`);
        // convert schema from string[] to string[][]
        // TODO not sure why we need this, could be refactored after removing antd generators
        const getSchemaOpts = { schema: [this.options.schema] };
        const schemaAsGqlObject = await (0, amplicodeGetGraphQLSchema_1.amplicodeGetGraphQLSchema)(getSchemaOpts, invocationDir);
        if (schemaAsGqlObject == null) {
            throw new Error("GraphQL Schema not provided (react-admin:update-schema)");
        }
        const schemaString = (0, raPrintSchema_1.raPrintSchema)(schemaAsGqlObject);
        await (0, raWriteSchema_1.raWriteSchema)(this, { schema: schemaString });
    }
}
exports.UpdateSchemaGenerator = UpdateSchemaGenerator;
exports.generator = UpdateSchemaGenerator;
const name = 'update-schema';
exports.name = name;
const isFrontendComponent = false;
exports.isFrontendComponent = isFrontendComponent;
//# sourceMappingURL=index.js.map