"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFrontendComponent = exports.description = exports.options = exports.generator = exports.name = exports.AuthFormLogin = void 0;
const tslib_1 = require("tslib");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeCommonOptionsConfig; } });
const path_1 = tslib_1.__importDefault(require("path"));
const write_1 = require("./write");
const answers_1 = require("./answers");
const template_model_1 = require("./template-model");
const ForceUpdateYeomanGenerator_1 = require("../ForceUpdateYeomanGenerator");
class AuthFormLogin extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.authFormLoginQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveAuthFormLoginTemplateModel,
                write: write_1.writeAuthFormLogin
            }
        }, this);
    }
}
exports.AuthFormLogin = AuthFormLogin;
exports.generator = AuthFormLogin;
const name = 'auth-form-login';
exports.name = name;
const description = 'Form login';
exports.description = description;
const isFrontendComponent = false;
exports.isFrontendComponent = isFrontendComponent;
//# sourceMappingURL=index.js.map