"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFrontendComponent = exports.params = exports.description = exports.options = exports.generator = exports.name = exports.AuthOidcKeycloak = void 0;
const tslib_1 = require("tslib");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeCommonOptionsConfig; } });
const path_1 = tslib_1.__importDefault(require("path"));
const write_1 = require("./write");
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.oidcQuestions; } });
const ForceUpdateYeomanGenerator_1 = require("../ForceUpdateYeomanGenerator");
class AuthOidcKeycloak extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.oidcQuestions,
            stages: {
                write: write_1.writeAuthOidcKeycloak
            }
        }, this);
    }
}
exports.AuthOidcKeycloak = AuthOidcKeycloak;
exports.generator = AuthOidcKeycloak;
const name = 'auth-oidc-keycloak';
exports.name = name;
const description = 'OIDC with Keycloak (JWT)';
exports.description = description;
const isFrontendComponent = false;
exports.isFrontendComponent = isFrontendComponent;
//# sourceMappingURL=index.js.map