import { Locale } from '../../../common/model/cuba-model';
import { Editor } from "mem-fs-editor";
/**
 * @property strict - if true then all i18n keys must be filled
 */
interface SupportClientLocation {
    name: string;
    strict: boolean;
}
export declare const SUPPORTED_CLIENT_LOCALES: SupportClientLocation[];
/**
 * Adds component i18n messages to the frontend client i18n message packs.
 * Also adds a menu item caption to the i18n file for locale `en`. The caption is constructed from the class name.
 * If any message already exists in the file - it will NOT be overwritten with a new value.
 *
 * @deprecated moved to building-blocks
 *
 * @param fs - yeoman fs
 * @param className - component class name
 * @param dirShift - directory depth from project root
 * @param projectLocales - locales enabled for this project.
 * If provided, i18n messages will be added only for these locales.
 * Otherwise, i18n messages for all locales supported by Frontend UI will be added
 * (this situation is possible if the project model was created using an older Studio version and does not
 * contain locales info).
 * @param componentMessagesPerLocale - an object where keys are locale codes (such as 'en' or 'ru) and values
 * are objects containing i18n key/value pairs for that locale.
 */
export declare function writeComponentI18nMessages(fs: Editor, className: string, dirShift?: string, projectLocales?: Locale[], componentMessagesPerLocale?: Record<string, Record<string, string>>): void;
export {};
