"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeEntityDetails = void 0;
const tslib_1 = require("tslib");
const mvp_1 = require("../../../building-blocks/stages/writing/pieces/mvp/mvp");
const path_1 = tslib_1.__importDefault(require("path"));
const writeDisplayNameFunctionsForRelations_1 = require("../../../building-blocks/stages/writing/pieces/display-name/writeDisplayNameFunctionsForRelations");
const writeGraphQLSchema_1 = require("../common/writeGraphQLSchema");
const writeDisplayNameFunction_1 = require("../../../building-blocks/stages/writing/pieces/display-name/writeDisplayNameFunction");
async function writeEntityDetails(templateModel, gen) {
    if (templateModel.mutationName != null && templateModel.mutationString != null) {
        await (0, mvp_1.writeAmplicodeComponent)(templateModel, gen, path_1.default.join(__dirname, 'template', 'EntityEditor.tsx.ejs'));
    }
    else {
        await (0, mvp_1.writeAmplicodeComponent)(templateModel, gen, path_1.default.join(__dirname, 'template', 'EntityDetails.tsx.ejs'));
    }
    await (0, writeDisplayNameFunction_1.writeDisplayNameFunction)({
        gen,
        entityName: templateModel.entityName,
        attributes: templateModel.allAttributes,
        dirShift: templateModel.relDirShift,
        idAttrName: templateModel.idField
    });
    await (0, writeDisplayNameFunctionsForRelations_1.writeDisplayNameFunctionsForRelations)(gen, templateModel.attributes, templateModel.relDirShift);
    (0, writeGraphQLSchema_1.writeGraphQLSchema)(gen, templateModel, path_1.default.join('..', templateModel.relDirShift));
}
exports.writeEntityDetails = writeEntityDetails;
//# sourceMappingURL=write.js.map