"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.index = exports.icon = exports.description = exports.caption = exports.params = exports.options = exports.generator = exports.name = exports.EntityListListGenerator = void 0;
const tslib_1 = require("tslib");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeComponentOptionsConfig; } });
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = tslib_1.__importDefault(require("path"));
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.entityListListQuestions; } });
const template_model_1 = require("./template-model");
const write_1 = require("../entity-list/write");
const ForceUpdateYeomanGenerator_1 = require("../ForceUpdateYeomanGenerator");
class EntityListListGenerator extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.entityListListQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveEntityListListTemplateModel,
                write: write_1.writeEntityList
            }
        }, this);
    }
}
exports.EntityListListGenerator = EntityListListGenerator;
exports.generator = EntityListListGenerator;
const name = 'entity-list-list';
exports.name = name;
const caption = 'Entity List';
exports.caption = caption;
const description = 'Set of entities displayed as list';
exports.description = description;
const icon = 'list.svg';
exports.icon = icon;
const index = 32;
exports.index = index;
//# sourceMappingURL=index.js.map