"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.index = exports.icon = exports.description = exports.caption = exports.params = exports.options = exports.generator = exports.name = exports.EntityListTableGenerator = void 0;
const tslib_1 = require("tslib");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeComponentOptionsConfig; } });
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = tslib_1.__importDefault(require("path"));
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.entityListTableQuestions; } });
const template_model_1 = require("./template-model");
const write_1 = require("../entity-list/write");
const ForceUpdateYeomanGenerator_1 = require("../ForceUpdateYeomanGenerator");
class EntityListTableGenerator extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.entityListTableQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveEntityListTableTemplateModel,
                write: write_1.writeEntityList
            }
        }, this);
    }
}
exports.EntityListTableGenerator = EntityListTableGenerator;
exports.generator = EntityListTableGenerator;
const name = 'entity-list-table';
exports.name = name;
const caption = 'Entity Table';
exports.caption = caption;
const description = 'Set of entities displayed as table';
exports.description = description;
const icon = 'table.svg';
exports.icon = icon;
const index = 31;
exports.index = index;
//# sourceMappingURL=index.js.map