import { UtilTemplateModel } from "../../../building-blocks/stages/template-model/pieces/util";
import { AmplicodeTemplateModelStage } from "../../../building-blocks/pipelines/amplicodePipeline";
import { AmplicodeComponentOptions } from "../../../building-blocks/stages/options/pieces/amplicode";
import { EntityListModeAnswer, EntityListAnswers, EntityListTypeAnswer } from "./answers";
import { GraphQLSchema } from "graphql";
import { BaseTemplateModel } from "../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel";
import { ScreenTemplateModel } from "../../../building-blocks/stages/template-model/pieces/amplicode/ScreenTemplateModel";
import { GqlAttributeModel } from "../../../building-blocks/stages/template-model/pieces/entity";
import { UsingScalars } from "../entity-details/template-model";
export interface EntityListTemplateModel extends BaseTemplateModel, UtilTemplateModel, ScreenTemplateModel, FiltersTemplateModel, OrderByTemplateModel, PaginationTemplateModel {
    queryName: string;
    route: string;
    queryString: string;
    deleteMutationName?: string;
    deleteMutationString?: string;
    idField: string;
    type: EntityListTypeTemplateModel;
    multiselect: boolean;
    mode: EntityListModeTemplateModel;
    attributes: GqlAttributeModel[];
    allAttributes: string[];
    itemComponentName?: string;
    refetchQuery: string;
    entityName: string;
}
export type EntityListTypeTemplateModel = 'cards' | 'list' | 'table';
export type EntityListModeTemplateModel = 'edit' | 'view' | 'view with details';
export declare const deriveEntityListTemplateModel: AmplicodeTemplateModelStage<AmplicodeComponentOptions, EntityListAnswers, EntityListTemplateModel>;
export interface FiltersTemplateModel {
    filters: GqlAttributeModel[];
    withFilters: boolean;
    hiddenFilters: GqlAttributeModel[];
    withHiddenFilters: boolean;
    maxFiltersInRow: number;
    filterUsingScalars: UsingScalars;
}
export declare function deriveFiltersTemplateModel(queryName: string, filterByArguments: Array<string[]> | undefined, schema: GraphQLSchema): FiltersTemplateModel;
export interface OrderByTemplateModel {
    orderByArguments?: string[];
    orderByType?: string;
    sortPropertyType?: string;
    sortDirectionType?: string;
    withOrderBy: boolean;
}
export declare function deriveOrderByTemplateModel(queryName: string, orderByArguments: string[] | undefined, schema: GraphQLSchema): OrderByTemplateModel;
type PaginationType = 'offset' | 'cursor';
export interface PaginationTemplateModel {
    paginationType?: PaginationType;
    paginationQueryPath?: string[];
    withPagination: boolean;
}
export declare function derivePatinationTemplateModel(queryName: string, paginationType: PaginationType | undefined, schema: GraphQLSchema): PaginationTemplateModel;
export declare function deriveMode(mode: EntityListModeAnswer): EntityListModeTemplateModel;
export declare function deriveType(type: EntityListTypeAnswer): EntityListTypeTemplateModel;
export {};
