"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeEntityList = void 0;
const tslib_1 = require("tslib");
const mvp_1 = require("../../../building-blocks/stages/writing/pieces/mvp/mvp");
const path_1 = tslib_1.__importDefault(require("path"));
const writeDisplayNameFunction_1 = require("../../../building-blocks/stages/writing/pieces/display-name/writeDisplayNameFunction");
const writeDisplayNameFunctionsForRelations_1 = require("../../../building-blocks/stages/writing/pieces/display-name/writeDisplayNameFunctionsForRelations");
const writeGraphQLSchema_1 = require("../common/writeGraphQLSchema");
async function writeEntityList(templateModel, gen) {
    let templateName;
    switch (templateModel.type) {
        case "list":
            templateName = 'List.tsx.ejs';
            break;
        case "cards":
            templateName = 'Cards.tsx.ejs';
            break;
        case "table":
            templateName = 'Table.tsx.ejs';
            break;
        default:
            throw new Error("unexpected template type " + templateModel.type);
    }
    // Write screen component
    await (0, mvp_1.writeAmplicodeComponent)(templateModel, gen, path_1.default.join(__dirname, '..', 'common', 'template', templateName));
    if (templateModel.type == 'cards') {
        // Write getXXXDisplayName() function for listed entity
        await (0, writeDisplayNameFunction_1.writeDisplayNameFunction)({
            gen,
            entityName: templateModel.entityName,
            attributes: templateModel.allAttributes,
            dirShift: templateModel.relDirShift,
            idAttrName: templateModel.idField
        });
    }
    await (0, writeDisplayNameFunctionsForRelations_1.writeDisplayNameFunctionsForRelations)(gen, templateModel.attributes, templateModel.relDirShift);
    (0, writeGraphQLSchema_1.writeGraphQLSchema)(gen, templateModel, path_1.default.join('..', templateModel.relDirShift));
}
exports.writeEntityList = writeEntityList;
//# sourceMappingURL=write.js.map