"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.index = exports.icon = exports.description = exports.caption = exports.params = exports.options = exports.generator = exports.name = exports.ReactEntityManagementGenerator = void 0;
const tslib_1 = require("tslib");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeComponentOptionsConfig; } });
const path_1 = tslib_1.__importDefault(require("path"));
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.commonEntityManagementQuestions; } });
const template_model_1 = require("./template-model");
const write_1 = require("./write");
const ForceUpdateYeomanGenerator_1 = require("../ForceUpdateYeomanGenerator");
class ReactEntityManagementGenerator extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.commonEntityManagementQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveManagementTemplateModel,
                write: write_1.writeManagement,
            }
        }, this);
    }
}
exports.ReactEntityManagementGenerator = ReactEntityManagementGenerator;
exports.generator = ReactEntityManagementGenerator;
const name = 'entity-management';
exports.name = name;
const caption = 'Entity Management';
exports.caption = caption;
const description = 'Standard entity editor and entity list screens created at once. The best choice for CRUD operations.';
exports.description = description;
const icon = 'entity-management.svg';
exports.icon = icon;
const index = 10;
exports.index = index;
//# sourceMappingURL=index.js.map