"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const template_model_1 = require("./template-model");
const chai_1 = tslib_1.__importStar(require("chai"));
const chai_as_promised_1 = tslib_1.__importDefault(require("chai-as-promised"));
chai_1.default.use(chai_as_promised_1.default);
const test_commons_1 = require("../../../test/test-commons");
describe('entity-management template-model stage', () => {
    it('should throw an error when edit mode and no upsert mutation', async () => {
        const answers = {
            listComponentName: 'TestOwnerCards',
            itemComponentName: 'TestOwnerCardsDetails',
            route: 'test-owner-cards',
            shouldAddToMenu: true,
            listQuery: `
        query Get_Owner_List {
          ownerList {
            id
            firstName
            lastName
            city
            address
            telephone
            email
          }
        }`,
            detailsQuery: `
        query Get_Owner($id: ID) {
          owner(id: $id) {
            id
            firstName
            lastName
            city
            address
            telephone
            email
          }
        }`,
            mode: 'Edit',
            type: 'Table',
            componentName: 'TestOwnerCards'
            // no upsertMutation!
        };
        await (0, chai_1.expect)((0, template_model_1.deriveManagementTemplateModel)({ schema: [['../../../../scripts/schema/schema.graphqls']], dirShift: '../../' }, answers, await (0, test_commons_1.getMockSchema)())).to.be.rejectedWith(template_model_1.EDIT_WITHOUT_UPSERT_ERROR);
    });
});
//# sourceMappingURL=template-model.test.js.map