"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeInsertedListFromArray = void 0;
const tslib_1 = require("tslib");
const path_1 = tslib_1.__importDefault(require("path"));
const base64_1 = require("../../../building-blocks/util/base64");
const ejs_1 = require("ejs");
const writeDisplayNameFunctionsForRelations_1 = require("../../../building-blocks/stages/writing/pieces/display-name/writeDisplayNameFunctionsForRelations");
const entity_1 = require("../../../building-blocks/stages/template-model/pieces/entity");
async function writeInsertedListFromArray(templateModel, gen) {
    const insertionPointTemplateName = 'insertionPointCards.tsx.ejs';
    const importsTemplateName = 'importsCards.tsx.ejs';
    const afterInsertionTemplateName = 'afterInsertionCards.jsx.ejs';
    const gqlAttributes = templateModel.attributes.filter(entity_1.isGqlAttributeModel);
    await (0, writeDisplayNameFunctionsForRelations_1.writeDisplayNameFunctionsForRelations)(gen, gqlAttributes, templateModel.relDirShift);
    const insertionPoint = await (0, ejs_1.renderFile)(path_1.default.join(__dirname, 'template', insertionPointTemplateName), templateModel);
    const imports = await (0, ejs_1.renderFile)(path_1.default.join(__dirname, 'template', importsTemplateName), templateModel);
    const afterInsertion = await (0, ejs_1.renderFile)(path_1.default.join(__dirname, 'template', afterInsertionTemplateName), templateModel);
    gen.fs.writeJSON(path_1.default.join(templateModel.responseFile), {
        insertionPoint: (0, base64_1.encodeBase64)(insertionPoint),
        imports: (0, base64_1.encodeBase64)(imports),
        afterInsertion: (0, base64_1.encodeBase64)(afterInsertion),
    });
}
exports.writeInsertedListFromArray = writeInsertedListFromArray;
//# sourceMappingURL=write.js.map