"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.description = exports.isFrontendComponent = exports.params = exports.options = exports.generator = exports.name = exports.InsertedListFromGqlGenerator = void 0;
const tslib_1 = require("tslib");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeInsertCodeOptionsConfig; } });
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = tslib_1.__importDefault(require("path"));
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.insertedListFromGqlQuestions; } });
const template_model_1 = require("./template-model");
const write_1 = require("./write");
const ForceUpdateYeomanGenerator_1 = require("../ForceUpdateYeomanGenerator");
class InsertedListFromGqlGenerator extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            questions: answers_1.insertedListFromGqlQuestions,
            stages: {
                deriveTemplateModel: template_model_1.deriveInsertedListFromGqlTemplateModel,
                write: write_1.writeInsertedListFromGql
            }
        }, this);
    }
}
exports.InsertedListFromGqlGenerator = InsertedListFromGqlGenerator;
exports.generator = InsertedListFromGqlGenerator;
const name = 'inserted-list-from-gql';
exports.name = name;
const description = 'Generate code from gql for inserting list with filter, sort and pagination to existing react component';
exports.description = description;
const isFrontendComponent = false;
exports.isFrontendComponent = isFrontendComponent;
//# sourceMappingURL=index.js.map