"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFrontendComponent = exports.options = exports.generator = exports.name = exports.UpdateSchemaGenerator = void 0;
const tslib_1 = require("tslib");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = tslib_1.__importDefault(require("path"));
const write_1 = require("./write");
const template_model_1 = require("./template-model");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeCommonOptionsConfig; } });
const ForceUpdateYeomanGenerator_1 = require("../ForceUpdateYeomanGenerator");
class UpdateSchemaGenerator extends ForceUpdateYeomanGenerator_1.ForceUpdateYeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    async generate() {
        await (0, amplicodePipeline_1.amplicodePipeline)({
            templateDir: path_1.default.join(__dirname, 'template'),
            stages: {
                deriveTemplateModel: template_model_1.deriveUpdateSchemaTemplateModel,
                write: write_1.writeSchema
            }
        }, this);
    }
}
exports.UpdateSchemaGenerator = UpdateSchemaGenerator;
exports.generator = UpdateSchemaGenerator;
const name = 'update-schema';
exports.name = name;
const isFrontendComponent = false;
exports.isFrontendComponent = isFrontendComponent;
//# sourceMappingURL=index.js.map